Qore::EncodingConversionInputStream Class Reference

An InputStream implementation that performs on-the-fly conversion between two character encodings. More...

Inheritance diagram for Qore::EncodingConversionInputStream:
[legend]

## Public Member Functions

| constructor (Qore::InputStream is, string sourceEncoding, string destEncoding)
| Creates the EncodingConversionInputStream based on the InputStream given. More...
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor. More...

## Detailed Description

An InputStream implementation that performs on-the-fly conversion between two character encodings.

Example: EncodingConversionInputStream basic usage
  EncodingConversionInputStream latin2Stream(sourceUtf8Stream, "UTF-8", "ISO-8859-2");
  binary *b;
  while (b = latin2Stream.read(20)) {
  #b contains up to 20 bytes representing latin-2 characters
  }

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

Since
  Qore 0.8.13

## Member Function Documentation

## constructor()

Qore::EncodingConversionInputStream::constructor | ( | Qore::InputStream | is,
|  | string | sourceEncoding,
|  | string | destEncoding
| ) |  |

Creates the EncodingConversionInputStream based on the InputStream given.

Parameters

  is | the source InputStream to read bytes from
  sourceEncoding | the encoding of the characters in the source input stream
  destEncoding | the destination character encoding

Exceptions

  ENCODING-CONVERSION-ERROR | if either of the encodings is unsupported

## peek()

int Qore::EncodingConversionInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  EncodingConversionInputStream latin2Stream(sourceUtf8Stream, "UTF-8", "ISO-8859-2");
  int nextByte = latin2Stream.peek();

Exceptions

  ENCODING-CONVERSION-ERROR | if an invalid multibyte sequence is encountered in the input
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.

## read()

*binary Qore::EncodingConversionInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Example:
  EncodingConversionInputStream latin2Stream(sourceUtf8Stream, "UTF-8", "ISO-8859-2");
  *binary b;
  while (b = latin2Stream.read(20)) {
  #b contains up to 20 bytes representing latin-2 characters
  }

Exceptions

  ENCODING-CONVERSION-ERROR | if an invalid multibyte sequence is encountered in the input
  INPUT-STREAM-ERROR | limit is not positive
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.